﻿using Syncfusion.Drawing;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Graphics;
using Syncfusion.Pdf.Grid;
using Syncfusion.Pdf.Interactive;
using Syncfusion.Pdf.Parsing;
using Syncfusion.Pdf.Security;
using System;
using System.Collections.Generic;
using System.Data;
using System.IO;
using System.Xml;

namespace NETCoreSample
{
    class Program
    {
        static void Main(string[] args)
        {
            //Create a new PDF document
            PdfDocument document = new PdfDocument();

            //Add a page
            PdfPage page = document.Pages.Add();

            //Create a PdfLightTable
            PdfGrid pdfGrid = new PdfGrid();

            //Add three columns
            pdfGrid.Columns.Add(2);

            //Add header
            pdfGrid.Headers.Add(1);

            PdfGridRow pdfGridHeader = pdfGrid.Rows.Add();
            pdfGridHeader.Cells[0].Value = "Shapes Name";
            pdfGridHeader.Cells[1].Value = "Shapes";

            //Add the rows
            PdfGridRow row1 = pdfGrid.Rows.Add();
            row1.Cells[0].Value = "Pie";
            row1.Height = 200;
            PdfGridRow row2 = pdfGrid.Rows.Add();
            row2.Cells[0].Value = "Arc";
            row2.Height = 200;

            pdfGrid.BeginCellLayout += PdfGrid_BeginCellLayout1;

            //Draw the PdfGrid
            pdfGrid.Draw(page, PointF.Empty);

            //Save the document
            MemoryStream stream = new MemoryStream();
            document.Save(stream);
            document.Close(true);

            stream.Position = 0;
            FileStream outStream = File.OpenWrite("Sample.pdf");
            stream.WriteTo(outStream);
            outStream.Flush();
            stream.Dispose();
        }

        private static void PdfGrid_BeginCellLayout1(object sender, PdfGridBeginCellLayoutEventArgs args)
        {
            //Initialize the pen for drawing pie
            PdfPen pen = new PdfPen(PdfBrushes.Brown, 10f);

            if (args.RowIndex == 1 && args.CellIndex == 1)
            {              
                //Set the line join style of the pen
                pen.LineJoin = PdfLineJoin.Round;

                RectangleF rectangle = new RectangleF(args.Bounds.X + 10, args.Bounds.Y, args.Bounds.Width, args.Bounds.Height);

                args.Graphics.DrawPie(pen, PdfBrushes.Green, rectangle, 180, 60);
            }

            if(args.RowIndex == 2 && args.CellIndex == 1)
            {
                //Set the line join style of the pen
                pen.LineCap = PdfLineCap.Square;

                RectangleF rectangle = new RectangleF(args.Bounds.X - 20, args.Bounds.Y+10, args.Bounds.Width, args.Bounds.Height);

                //Draw the arc on PDF document
                args.Graphics.DrawArc(pen, rectangle, 270, 90);
            }
        }
    }
}